> For the complete documentation index, see [llms.txt](https://docs.autogon.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.autogon.ai/autogon-engine-studio/deep-learning/restricted-boltzmann-machine-dl_rbm.md).

# Restricted Boltzmann Machine (DL\_RBM)

An RBM is a type of neural network used for unsupervised learning. It has two layers of neurons - visible and hidden - that are connected by weights. RBMs are unique because they have symmetric connections between the visible and hidden layers and no connections within the same layer. They use contrastive divergence to adjust the weights and learn complex probability distributions of the input data. RBMs are used in applications such as image and speech recognition, dimensionality reduction, and collaborative filtering. They can learn without labeled data and be used as building blocks for larger neural network architectures.

## Sample Request

Build an RBM for data clustering

```json
{
    "project_id": 1,
    "parent_id": 7,
    "block_id": 8,
    "function_code": "DL_RBM_I",
    "args": {
    "hyp_params":{
            "n_components": 5,
            "n_iter": 5
        }
    }
}
```

## Building a Restricted Boltzmann Machine

## RBM Construction

<mark style="color:green;">`POST`</mark> `https://autogon.ai/api/v1/engine/start`

#### Request Body

| Name                                             | Type   | Description                                                         |
| ------------------------------------------------ | ------ | ------------------------------------------------------------------- |
| project\_id<mark style="color:red;">\*</mark>    | int    | The `id` of the current project                                     |
| block\_id<mark style="color:red;">\*</mark>      | int    | The `id` of the current block                                       |
| function\_code<mark style="color:red;">\*</mark> | string | The function code for current block                                 |
| parent\_id<mark style="color:red;">\*</mark>     | int    | The `id` of the previous block                                      |
| args<mark style="color:red;">\*</mark>           | object | Block arguments                                                     |
| n\_components                                    | int    | Number of binary hidden units                                       |
| n\_iter                                          | int    | Number of iterations over the dataset                               |
| random\_state                                    | int    | Pass an int for reproducible results across multiple function calls |
| learning\_rate                                   | float  | The learning rate for weight updates                                |

{% tabs %}
{% tab title="200 Statemanagement object" %}

```json
{
    "status": "true",
    "message": {
        "id": 8,
        "project": 1,
        "block_id": 8,
        "parent_id": 7,
        "dataset_url": "",
        "x_value_url": "",
        "y_value_url": "",
        "x_train_url": "",
        "y_train_url": "",
        "x_test_url": "",
        "y_test_url": "",
        "output": {}
    }
}
```

{% endtab %}
{% endtabs %}

## Sample Request

Compile and train the pre-built RBM model, using passed in Hyper Parameters

```json
{
    "project_id": 1,
    "parent_id": 8,
    "block_id": 9,
    "function_code": "DL_RBM_T",
    "args": {
        "model_name": "titanic_model",
        "hyp_params":{
        }
    }
}
```

## Training a Restricted Boltzmann Machine

## RBM Training

<mark style="color:green;">`POST`</mark> `https://autogon.ai/api/v1`

#### Request Body

| Name                                             | Type   | Description                                         |
| ------------------------------------------------ | ------ | --------------------------------------------------- |
| project\_id<mark style="color:red;">\*</mark>    | int    | The `id` of the current project                     |
| hyp\_params                                      | object | hyper parameters for model compilation and training |
| parent\_id<mark style="color:red;">\*</mark>     | int    | The `id` of the previous block                      |
| block\_id<mark style="color:red;">\*</mark>      | int    | The `id` of the current block                       |
| function\_code<mark style="color:red;">\*</mark> |        | The function code for current block                 |
| args<mark style="color:red;">\*</mark>           | object | Block arguments                                     |
| model\_name<mark style="color:red;">\*</mark>    | String | The name the model would be saved with              |

{% tabs %}
{% tab title="200: OK Statemanagement Object" %}

```json
{
    "status": "true",
    "message": {
        "id": 9,
        "project": 1,
        "block_id": 9,
        "parent_id": 8,
        "dataset_url": "",
        "x_value_url": "",
        "y_value_url": "",
        "x_train_url": "",
        "y_train_url": "",
        "x_test_url": "",
        "y_test_url": "",
        "output": {}
    }
}
```

{% endtab %}
{% endtabs %}

## Sample Request

Make predictions with the trained RBM model.

```json
{
    "project_id": 1,
    "parent_id": 8,
    "block_id": 9,
    "function_code": "DL_RBM_P",
    "args": {
        "test_data": "",
    }
}
```

## Predicting with a Restricted Boltzmann Machine

## RBM Predict

<mark style="color:green;">`POST`</mark> `https://autogon.ai/api/v1/engine/start`

#### Request Body

| Name                                             | Type   | Description                         |
| ------------------------------------------------ | ------ | ----------------------------------- |
| test\_data<mark style="color:red;">\*</mark>     | String | Input data for prediction           |
| project\_id<mark style="color:red;">\*</mark>    | int    | ID of the current project           |
| block\_id<mark style="color:red;">\*</mark>      | int    | ID of the current block             |
| parent\_id<mark style="color:red;">\*</mark>     | int    | ID of the previous block            |
| function\_code<mark style="color:red;">\*</mark> | String | Function code for the current block |
| args<mark style="color:red;">\*</mark>           | object | Block arguments                     |

{% tabs %}
{% tab title="200: OK Statemanagement object" %}

```javascript
{
    "status": "true",
    "message": {
        "id": 9,
        "project": 1,
        "block_id": 9,
        "parent_id": 8,
        "dataset_url": "",
        "x_value_url": "",
        "y_value_url": "",
        "x_train_url": "",
        "y_train_url": "",
        "x_test_url": "",
        "y_test_url": "",
        "output": {}
    }
}
```

{% endtab %}
{% endtabs %}

{% tabs %}
{% tab title="Python" %}

```
// Some code
```

{% endtab %}

{% tab title="Node" %}

```
// Some code
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.autogon.ai/autogon-engine-studio/deep-learning/restricted-boltzmann-machine-dl_rbm.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
